#include <nucleo_usart.h>
//#include <stm_core.h>

int Usart2Send(char c) //Funkce odesln
{
  while(!(USART2->SR & USART_SR_TXE)) //ekn na dokonen ppadnho probhajcho vysln
    ;                                     // cekej dokud neni volny TDR

  USART2->DR = c;                     // zapis do TDR k odeslani, Zapsat do TDR nov data k odesln
  return c;
}

int Usart2Recv(void) //Funkce na pjem

{
  while(!(USART2->SR & USART_SR_RXNE))      // cekej dokud neprijde, musi to tam byt abych poznal rozdil mezi tim ze jsem nic neprijal a tim ze jsem prijal nulu
    ;

  return USART2->DR;                        // vycti a vrat jako hodnotu
}

bool IsUsart2Recv(void)                     // priznak, ze je neco v bufferu, test existence pijatch dat
{
  return (USART2->SR & USART_SR_RXNE) != 0;
  // podminka vynuti true/false vysledek
}

void Usart2String(char *txt) // funkce pro vpis text
{
  while(*txt)
  {
    Usart2Send(*txt);
    txt++;
  }
}

void Usart2Init(int baudRate)
{
  Nucleo_SetPinGPIO(GPIOA, 2, ioPortAlternatePP);
  Nucleo_SetAFGPIO(GPIOA, 2, 7);                  // AF7 je USART2
  Nucleo_SetPinGPIO(GPIOA, 3, ioPortAlternatePP);
  Nucleo_SetAFGPIO(GPIOA, 3, 7);                // AF7 je USART2

  if (!(RCC->APB1ENR & RCC_APB1ENR_USART2EN)) // neni povolen USART2
  {
    RCC->APB1ENR |= RCC_APB1ENR_USART2EN;
    RCC->APB1RSTR |= RCC_APB1RSTR_USART2RST;
    RCC->APB1RSTR &= ~RCC_APB1RSTR_USART2RST;
  }
  USART2->CR1 = USART_CR1_RE | USART_CR1_TE;        // staci povoleni prijmu a vysilani
  USART2->CR2 = 0;                                  // nic specialniho
  USART2->CR3 = 0;                                  // nic specialniho

  // bd = apb1 / (16 x DIV) .... DIV = APB1 / (16 x BD) = 16M / (16 x baud)
  // pro baud = 38400 vyjde DIV = 26,041666, 1/16 = 0,625, tedy 26 = 0x1A a spodni 4b = 0x1
  // blok pro lokalni promenne
  {
    uint sampling = (USART2->CR1 & USART_CR1_OVER8) ? 8 : 16;
    uint32_t apb1, mant, tmp, frac;

    apb1 = SystemCoreClock; //TODO zjistit presne z RCC->CFGR registru deleni

    mant = apb1 * 100 / (sampling * baudRate); // v setinach
    tmp = mant / 100;
    frac = mant - (tmp * 100); // zbyvajici cast 0-99 nutno prevest na 0-15
    frac = ((((frac * sampling) + 50) / 100)); // +50 kvli zaokrouhlovani oezem intu

    USART2->BRR = (tmp << 4) | (frac & 0x0f); // mantisa vyssich 12b, zlomek dolni 4b, celkem 16b
  }

  //USART2->BRR = 0x1A1;                      // rychlost 38400 pri 16MHz - spocitano predem
  USART2->CR1 |= USART_CR1_UE;                  // az na zaver povolen blok USARTu

  // zrusit bufferovani vystupu i vstupu
  setvbuf(stdout, NULL, _IONBF, 0);
  setvbuf(stdin, NULL, _IONBF, 0);
}




